#import "Exercise4.h"

@implementation Exercise4

- (IBAction)calculate:(id)sender
{
	// http://www.nunochu.com/bible/easter/calc.html
	
	int	anYear=[yearField intValue];
	int	aValue1, aValue2;
	int	aMonth, aDate;
	
	//step(1)
	aValue1=anYear%19;
	
	//step(2)
	aValue1=225-aValue1*11;
	
	//step(3)
	if(aValue1>=51)
	{
		while(aValue1>=51)
			aValue1-=30;
	}
	
	//step(4)
	if(aValue1>48)
		aValue1-=1;
		
	//step(5) ->step(7)で(4)の計算結果を使うのでaValue1の値を残しておく！
	aValue2=anYear+anYear/4+aValue1+1;
	
	//step(6)
	aValue2=aValue2%7;
	
	//step(7)
	aValue1=aValue1+7-aValue2;
	
	//step(8)
	if(aValue1>31)
	{
		aMonth=4;
		aDate=aValue1-31;
	}
	else
	{
		aMonth=3;
		aDate=aValue1;
	}
	
	[monthField setIntValue:aMonth];
	[dateField setIntValue:aDate];
}



- (IBAction)listupEaster:(id)sender
{
	int	anYear, aMonth, aDate;
	
	for( anYear=0; anYear<=3000; ++anYear )
	{
		calculateEaster(anYear, &aMonth, &aDate);
		NSLog(@"%4d/%2d/%2d", anYear, aMonth, aDate);
	}
}

void calculateEaster(int pYear, int *pMonth, int *pDate)
{
	int	aValue1, aValue2;

	//step(1)
	aValue1=pYear%19;
	
	//step(2)
	aValue1=225-aValue1*11;
	
	//step(3)
	if(aValue1>=51)
	{
		while(aValue1>=51)
			aValue1-=30;
	}
	
	//step(4)
	if(aValue1>48)
		aValue1-=1;
		
	//step(5) ->step(7)で(4)の計算結果を使うのでaValue1の値を残しておく！
	aValue2=pYear+pYear/4+aValue1+1;
	
	//step(6)
	aValue2=aValue2%7;
	
	//step(7)
	aValue1=aValue1+7-aValue2;
	
	//step(8)
	if(aValue1>31)
	{
		*pMonth=4;
		*pDate=aValue1-31;
	}
	else
	{
		*pMonth=3;
		*pDate=aValue1;
	}
}

@end
